Program Approximation_by_Increasing_Sequence;
{Solution by dynamical programming}
{With O(N) memory requirement }

Const MaxN=1000000;

Var xsort: Array [1..MaxN] of LongInt;

  Procedure QuickSort(L,R: LongInt);
  Var k, j: LongInt;
      treshold, w: LongInt;
  Begin
    k:=L; j:=R;
    treshold:=xsort[(L+R) div 2];
    Repeat
      While (xsort[k]<treshold) Do Inc(k);
      While (treshold<xsort[j]) Do Dec(j);
      If (k<=j) Then
      Begin
        w:=xsort[j]; xsort[j]:=xsort[k]; xsort[k]:=w;
        Inc(k); Dec(j);
      End;
    Until (k>j);
    If (L<j) Then QuickSort(L,j);
    If (k<R) Then QuickSort(k,R);
  End; {QuickSort}

Var x: Array [1..MaxN] of LongInt;
    res: Array [1..MaxN] of LongInt;
    aim, aim0: Array [1..MaxN] of Int64;
    n, i, j, k: LongInt;
    min: Int64;
    others: LongInt;
    f: Text;

Begin
{INPUT}
  Assign(f,'sequence.in'); Reset(f);
  Readln(f,n);
  min:= MaxLongInt;
  For i:= 1 To n Do Begin
    Readln(f,x[i]);
    Dec(x[i],i);
  End;
  Close(f);

{RENUMERATION}
  Move(x,xsort,SizeOf(x));
  QuickSort(1,n);
  others:= 1;
  i:= 2;
  While (i<=n) Do Begin
    If xsort[i]<>xsort[others] Then Begin
      Inc(others);
      xsort[others]:= xsort[i];
    End;
    Inc(i);
  End;

{SEARCH}
  {Direct motion}
  For j:= 1 To others Do Begin
    aim[j]:= abs(x[1]-xsort[j]);
  End;

  For i:= 2 To n Do Begin
    If (i=n) Then Move(aim, aim0, SizeOf(aim));
    min:= aim[1];
    For j:= 1 To others Do Begin
      If min>aim[j] Then min:= aim[j];
      aim[j]:= min+abs(x[i]-xsort[j]);
    End;
  End;

  {Reverse motion and output}
  min:= aim[1];
  j:= 1;
  For i:= 2 To others Do Begin
    If min>aim[i] Then Begin
      min:= aim[i];
      j:= i;
    End;
  End;

  Assign(f,'sequence.out'); Rewrite(f);
  Writeln(f,min);

  res[n]:= xsort[j];
  others:= j;

  For k:= n-1 DownTo 1 Do Begin
    While (aim[others]<>aim0[others]+abs(x[k+1]-xsort[others])) Do
      Dec(others);
    res[k]:= xsort[others];
    {Array aim recalculation}
    If (k>1) Then Begin
      Move(aim0, aim, SizeOf(aim));
      For j:= 1 To others Do Begin
        aim0[j]:= abs(x[1]-xsort[j]);
      End;
      For i:= 2 To k-1 Do Begin
        min:= aim0[1];
        For j:= 1 To others Do Begin
          If min>aim0[j] Then min:= aim0[j];
          aim0[j]:= min+abs(x[i]-xsort[j]);
        End;
      End;
    End;
  End;
  For i:= 1 To n Do Begin
    Writeln(f,res[i]+i);
  End;
  Close(f);
End.
