Program Approximation_by_Increasing_Sequence;
{Solution in the mathematical induction style}

Const MaxN=1000000;

Var x: Array [1..MaxN] of LongInt; {Global array}

Function Median(st1, fin1, fin2: LongInt): LongInt;
{Sorting on array x by mergesort}
Var  w: Array [1..MaxN] of LongInt;
     i1,i2,j,k,delta: LongInt;
Begin
  i1:= st1;
  i2:= fin1+1;
  j:= st1;
  While (i1<=fin1) and (i2<=fin2) Do Begin
    If x[i1]<=x[i2] Then Begin
      w[j]:= x[i1];
      Inc(i1);
    End
    Else Begin
      w[j]:= x[i2];
      Inc(i2);
    End;
    Inc(j);
  End;
  If (i2>fin2) Then Begin
    delta:= fin2-fin1;
    For k:= fin1 DownTo i1 Do Begin
      x[k+delta]:= x[k]
    End;
  End;
  For k:= st1 To j-1 Do Begin
    x[k]:= w[k];
  End;
  Median:= x[(st1+fin2) div 2];
End;

Type PList = ^ListLmnt;
     ListLmnt = Record
       median: LongInt;
       lastno: LongInt;
       prev: PList;
     End;

Var medList, ptmp, pptmp: PList;
    n, i, st1, fin1, fin2: LongInt;
    result: Int64;
    f: Text;

Begin
{INPUT}
  Assign(f,'sequence.in'); Reset(f);
  Readln(f,n);
  For i:= 1 To n Do Begin
    Readln(f,x[i]);
    Dec(x[i],i);
  End;
  Close(f);
{Canonical decision sequence construction}
  New(medList);
  medList^.prev:= Nil;
  medList^.lastno:= 0;
  medList^.median:= -MaxLongInt;
  For i:= 1 To n Do Begin
    {Add current element}
    new(ptmp);
    ptmp^.prev:= medList;
    medList:= ptmp;
    medList^.lastno:= i;
    medList^.median:= x[i];
    {Incapsulation - rebuild the canonical decision sequence}
    While (medList^.prev^.lastno<>0) and (medList^.median<medList^.prev^.median) Do Begin
      st1:= medList^.prev^.prev^.lastno + 1;
      fin1:= medList^.prev^.lastno;
      fin2:= medList^.lastno;
      ptmp:= medList^.prev;
      medList^.prev:= ptmp^.prev;
      Dispose(ptmp);
      medList^.median:= Median(st1, fin1, fin2);
    End;
  End;

{OUTPUT}
  Assign(f,'sequence.out'); Rewrite(f);
  {Calculate and output the least common deviation}
  result:= 0;
  ptmp:= medList^.prev;
  medList^.prev:= Nil;
  Repeat
    For i:= ptmp^.lastno+1 To medList^.lastno Do Begin
      result:= result + abs(x[i]-medList^.median);
    End;
    pptmp:= ptmp^.prev;
    ptmp^.prev:= medList;
    medList:= ptmp;
    ptmp:= pptmp;
  Until (ptmp=Nil);
  Writeln(f,result);
  {Output the decision sequence}
  Repeat
    ptmp:= medList;
    medList:= medList^.prev;
    For i:= ptmp^.lastno+1 To medList^.lastno Do Begin
      Writeln(f,medList^.median+i);
    End;
    Dispose(ptmp);
  Until (medList^.lastno=n);
  Dispose(medList);
  Close(f);
End.
